﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace HtmlWpfRtf.Common {
    /// <summary>
    /// Interaktionslogik für FSelectColorConstant.xaml
    /// </summary>
    public partial class WSelectColorConstant : Window {

        private bool retcode = false;  // Abbruch

        public bool RetCode {
            get { return retcode; }
        }

        string sColor = "";

        public String SelectedColor {
            get { return sColor; }
        }

        public WSelectColorConstant() {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            listboxColor.Items.Clear();
            listboxColor.Items.Add("white");
            listboxColor.Items.Add("red");
            listboxColor.Items.Add("blue");
            listboxColor.Items.Add("black");
            listboxColor.Items.Add("green");
            listboxColor.Items.Add("yellow");
            listboxColor.Items.Add("cyan");
            listboxColor.Items.Add("magenta");
            listboxColor.Items.Add("purple");
            listboxColor.Items.Add("navy");
            listboxColor.Items.Add("olive");
            listboxColor.Items.Add("lime");
            listboxColor.Items.Add("aqua");
            listboxColor.Items.Add("teal");
            listboxColor.Items.Add("silver");
            listboxColor.Items.Add("maroon");
            listboxColor.SelectedIndex = 0;
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            sColor = (String)listboxColor.Items[listboxColor.SelectedIndex];
            retcode = true;
            Close();
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                bnOk_Click(sender, e);
            }
        }

        private void listboxColor_SelectionChanged(object sender, SelectionChangedEventArgs e) {
            switch (listboxColor.SelectedIndex) {
                case 0: panelColor.Background = Brushes.White;
                    break;
                case 1: panelColor.Background = Brushes.Red;
                    break;
                case 2: panelColor.Background = Brushes.Blue;
                    break;
                case 3: panelColor.Background = Brushes.Black;
                    break;
                case 4: panelColor.Background = Brushes.Green;
                    break;
                case 5: panelColor.Background = Brushes.Yellow;
                    break;
                case 6: panelColor.Background = Brushes.Cyan;
                    break;
                case 7: panelColor.Background = Brushes.Magenta;
                    break;
                case 8: panelColor.Background = Brushes.Purple;
                    break;
                case 9: panelColor.Background = Brushes.Navy;
                    break;
                case 10: panelColor.Background = Brushes.Olive;
                    break;
                case 11: panelColor.Background = Brushes.Lime;
                    break;
                case 12: panelColor.Background = Brushes.Aqua;
                    break;
                case 13: panelColor.Background = Brushes.Teal;
                    break;
                case 14: panelColor.Background = Brushes.Silver;
                    break;
                case 15: panelColor.Background = Brushes.Maroon;
                    break;
            }

        }
    }
}
