﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.IO;
using System.Windows.Controls;

namespace HtmlWpfRtf {
    public class Modell {



        private String filename = "";
        private String htmlFilename = "";

        private Boolean modified = false;

        private String editText = "";

        private MyTabItem tabpage = null;

        public String Filename {
            set {
                String falt = Basis.changeFilenameExt(Basis.getFilename(filename), "css");
                if (editText.IndexOf(falt) >= 0) {
                    String fneu = Basis.changeFilenameExt(Basis.getFilename(value), "css");
                    editText = editText.Replace(falt, fneu);
                    filename = value;
                    saveFile1();
                    ((MyTextBox)tabpage.Content).EditorText = editText;
                }
                else {
                    filename = value;
                }
                if (tabpage != null) {
                    tabpage.Title = Basis.getFilename(filename);
                }
            }
            get { return filename; }
        }

        public String Htmlfilename {
            set {
                htmlFilename = value;
            }
            get { return htmlFilename; }
        }

        public Boolean Modified {
            set { modified = value; }
            get { return modified; }
        }

        public String EditText {
            set { editText = value; }
            get { return editText; }
        }

        public Modell(MyTabItem tabpage) {
            this.tabpage = tabpage;
        }
          

        public String loadFile(String filename) {
            try {
                this.filename = filename;
                FileStream oFile;
                oFile = new FileStream(filename, FileMode.Open);
                StreamReader inStream = new StreamReader(oFile, true); // Encoding.ASCII);  UTF7 UTF8
                //editText = inStream.ReadToEnd();
                editText = inStream.ReadToEnd().Replace("\t", Konst.C_TAB);
                int i1 = editText.IndexOf("\r\n");
                int i2 = editText.IndexOf("\n");
                if ( i1==-1  && i2>=0) {
                    editText = editText.Replace("\n", "\r\n");
                }
                //int i3 = editText.IndexOf("\r\n");
                //int i4 = editText.IndexOf("\n");
                inStream.Close();
                this.modified = false;
                return editText;
            }
            catch (Exception e) {
                Basis.ErrorMsg("Error at the load of the file\r\nError: " + e.ToString(), "Error");
                return "";
            }
        }

        internal void saveTempFile()   {
            if (!filename.Equals("")) {
                // Backup
                String ext = Basis.getFilenameExt(filename);
                String backupfilename = Basis.changeFilenameExt(filename, "_" + ext);
                try {
                    File.WriteAllText(backupfilename, editText.Replace(Konst.C_TAB, "\t"));
                }
                catch(Exception e) {
                    Basis.ErrorMsg("Error at the save of the backupfile\r\nError: "+e.ToString(), "Error");
                }
                modified = false;
            }
        }

        public void saveFile1() {
            try {
                if (!filename.Equals("")) {
                    // Backup
                    if (File.Exists(filename)) {
                        String ext = Basis.getFilenameExt(filename);
                        String backupfilename = Basis.changeFilenameExt(filename, "~" + ext);
                        File.Copy(filename, backupfilename, true);
                    }
                    int len = editText.Length;
                    if (len > 0) {
                        String s = editText.Replace(Konst.C_TAB, "\t");
                        File.WriteAllText(filename, editText.Replace(Konst.C_TAB, "\t"));
                    }
                    modified = false;
                }
            }
            catch (Exception e) {
                Basis.ErrorMsg("Error at the save of the file\r\nError: " + e.ToString(), "Error");
            }
        }  // saveFile

    }
}
